﻿function UI() {
    var _ = this;
    _.GATHER_REGEXS = null;
    _.IsShowButtonInPage = 'true';
    _.IsShowGatherButton = 'false';
    _.IsShowCollectButton = 'true';
    _.IsAutoSlideAE = 'true';
    _.IsAlibaba = location.host == 'www.alibaba.com';
    _.IsEbay =
        location.host == 'www.ebay.com' || location.host == 'cn.ebay.com';
    _.Is1688 = location.host == 's.1688.com';
    _.Is1688Detail = location.host == 'detail.1688.com';
    _.IsDhgate = location.host == 'www.dhgate.com';
    _.IsAmazon = location.host.includes('www.amazon');
    _.IsMiravia = location.host.includes('www.miravia');
    _.IsAliexpress = location.host == 'www.aliexpress.com';
    _.IsPtAliexpress = location.host == 'pt.aliexpress.com';
    _.IsLazada = location.host.includes('www.lazada');
    _.IsShopeeSeller =
        location.host.includes('seller') && location.host.includes('shopee');
    _.IsXiapiBuy = location.host.includes('xiapibuy.com');
    _.IsDhgateSeller = location.host.includes('seller.dhgate');
    _.IsYiwugo = location.host.includes('yiwugo.com');
    _.IsSzwego = location.host.includes('szwego.com');
    _.IsDoba = location.host.includes('doba.com');
    _.IsShein = location.host.includes('shein.com');
    _.IsGigab2b = location.host.includes('gigab2b.com');
    _.IsTemu = location.host.includes('temu.com');
    _.IsBlibili = location.host.includes('blibli.com');
    _.ResponseBodyUrls = [
        // 'https://detail.tmall.com/item.htm',
        // 'https://item.taobao.com/item.htm',
    ];
    _.IsShowLogo = false;
    _.TabInfo = {};
    _.IsRepsponseDone = false;
    _.downloadImages = [];
    _.downloadBase64List = [];
    _.downloadImageIndex = 0;

    _.init = function() {
        _.trySavePurchaseMd5();
        _.tryShowPurchase();
        _.tryAutoOrder();
        _.tryAutoAuthorize();
        _.trySubmitHtml();

        chrome.runtime.sendMessage(
            {
                act: 'getGatherRegex',
            },
            function(e) {
                _.GATHER_REGEXS = e.GATHER_REGEXS;
                _.load();
            }
        );

        _.startListen();

        if (location.host == 'account.seller.shopee.com') _.autoSetSPCF();
    };

    _.trySubmitHtml = function() {
        chrome.runtime.sendMessage(
            {
                act: 'GetLocalStorage',
                keys: ['SlideVerifyInfo'],
            },
            function(e) {
                const { SlideVerifyInfo } = e.config;
                if (SlideVerifyInfo) {
                    const datas = JSON.parse(SlideVerifyInfo);
                    datas.url = location.href;
                    if (
                        _.IsAutoSlideAE == 'true' &&
                        location.href.includes('aliexpress.com') &&
                        $("p:contains('通过验证以确保正常访问')").length > 0
                    ) {
                        _.tryAutoSlide({ data: datas });
                    } else {
                        chrome.runtime.sendMessage({
                            act: 'getQueryTabs',
                            data: datas,
                        });
                    }
                }
            }
        );
    };

    _.dragandDrop = function(data) {
        const { id, clientX, clientY, distance } = data;
        var elem = document.getElementById(id),
            k = 0,
            interval;
        iME(elem, 'mousedown', 0, 0, clientX, clientY);
        interval = setInterval(function() {
            k += 10;
            iter(k);
            if (k === distance) {
                clearInterval(interval);
                iME(elem, 'mouseup', clientX + k, clientY, 220 + k, 400);
            }
        }, 10);
        function iter(y) {
            iME(elem, 'mousemove', clientX + y, clientY, clientX + y, clientY);
        }
        function iME(
            obj,
            event,
            screenXArg,
            screenYArg,
            clientXArg,
            clientYArg
        ) {
            var mousemove = document.createEvent('MouseEvent');
            mousemove.initMouseEvent(
                event,
                true,
                true,
                window,
                0,
                screenXArg,
                screenYArg,
                clientXArg,
                clientYArg,
                0,
                0,
                0,
                0,
                0,
                null
            );
            obj.dispatchEvent(mousemove);
        }
    };

    _.tryAutoSlide = function(res, response) {
        setTimeout(() => {
            if (
                _.IsAutoSlideAE == 'true' &&
                location.href.includes('aliexpress.com') &&
                $("p:contains('通过验证以确保正常访问')").length > 0
            ) {
                setInterval(() => {
                    if (document.getElementById('nc_1_n1z')) {
                        chrome.runtime.sendMessage({
                            act: 'gatherUpdateTab',
                            data: res.data,
                        });
                    } else if (document.getElementById('nc_1_wrapper')) {
                        _.dragandDrop({
                            id: 'nc_1_wrapper',
                            clientX: 100,
                            clientY: 0,
                            distance: 1000,
                        });
                    }
                }, 2000);
            } else _.gatherCurrentHtml(res, response);
        }, 2000);
    };

    _.autoSetSPCF = function() {
        let timer = setInterval(() => {
            if ($('.username').find('.shopee-input__input').length > 0) {
                $('.username')
                    .find('.shopee-input__input')
                    .on('input propertychange', function() {
                        chrome.runtime.sendMessage(
                            {
                                act: 'GetLocalStorage',
                                keys: ['shopee_spc_f_options'],
                            },
                            e => {
                                if (e.config && e.config.shopee_spc_f_options) {
                                    const options = JSON.parse(
                                        e.config.shopee_spc_f_options
                                    );
                                    const option = options.find(
                                        el => el.name == $(this).val()
                                    );
                                    if (option) {
                                        var keys = document.cookie.match(
                                            /[^ =;]+(?=\=)/g
                                        );
                                        if (keys) {
                                            for (var i = keys.length; i--; ) {
                                                if (keys[i] != 'SPC_F') {
                                                    document.cookie =
                                                        keys[i] +
                                                        '=0;path=/;expires=' +
                                                        new Date(
                                                            0
                                                        ).toUTCString();
                                                }
                                            }
                                        }
                                        document.cookie =
                                            'SPC_F=' +
                                            option.code +
                                            '; domain=.account.seller.shopee.com' +
                                            '; expires=' +
                                            new Date() +
                                            '; path=/';
                                    }
                                }
                            }
                        );
                    });
                clearInterval(timer);
                return;
            }
        }, 1000);
    };

    _.inputSetVal = function(id, child, val, response) {
        // 获取 input 输入框的dom对象
        var username = window.document.querySelector(id);
        if (username && child) username = username.querySelector(child);

        if (!username) {
            setTimeout(() => {
                _.inputSetVal(id, child, val, response);
            }, 1000);
            return response({ success: false });
        }

        // JavaScript 中的 `_valuetracker` 方法常常用于监听 HTML 表单元素（如 input，select，textarea 等）的值变化，并在每次值发生变化时执行回调函数。
        if (username._valueTracker)
            var _templMethod = username._valueTracker.getValue;
        if (username.getValue) var _templMethod = username.getValue;
        if (username._valueTracker) username._valueTracker.getValue = () => '';

        // 修改input的值
        username.value = val;

        // 设置输入框的 input 事件
        var event = new InputEvent('input', {
            bubbles: true, // 表示事件对象是否冒泡
            cancelable: true, // 表示事件是否可以被取消，即能否用Event.preventDefault()取消这个事件。
        });
        // 触发 dom 对象的 input 事件
        username.dispatchEvent(event);

        // 将`_valuetracker`的值（方法）重新绑定
        if (username._valueTracker)
            username._valueTracker.getValue = _templMethod;
        return response({ success: true });
    };

    _.tryAutoAuthorize = function() {
        if (
            location.href.includes('auth.lazada.com/oauth/authorize') &&
            location.href.includes('tferp.net/authorize/callback/Lazada')
        ) {
            chrome.runtime.sendMessage(
                {
                    act: 'GetLocalStorage',
                    keys: ['AuthorizeUserInfo'],
                },
                function(e) {
                    const { AuthorizeUserInfo } = e.config;
                    if (AuthorizeUserInfo) {
                        const { items, url, token } = JSON.parse(
                            AuthorizeUserInfo
                        );
                        if (items.length > 0) {
                            if (
                                $(
                                    ".danger-tip:contains('We have detected that you are already logged in and can be authorized immediately:')"
                                ).length > 0
                            ) {
                                const username = $("input[type='email']").val();
                                if (username == items[0].username)
                                    $("button[id='sub']").click();
                                else
                                    document
                                        .getElementsByClassName('form-tip')[0]
                                        .click();
                            } else {
                                $('#country').click();
                                $(
                                    ".next-menu-item:contains('Crossborder')"
                                ).click();
                                _.inputSetVal(
                                    '#fm-login-id',
                                    '',
                                    items[0].username,
                                    function(e) {
                                        if (e.success) {
                                            _.inputSetVal(
                                                '#fm-login-password',
                                                '',
                                                items[0].password,
                                                function(e) {
                                                    if (e.success) {
                                                        $(
                                                            '#fm-login-submit'
                                                        ).click();
                                                        setTimeout(() => {
                                                            if (
                                                                $(
                                                                    ".next-feedback-title:contains('USER_NOT_EXIST')"
                                                                ).length > 0
                                                            ) {
                                                                items.shift();
                                                                chrome.runtime.sendMessage(
                                                                    {
                                                                        act:
                                                                            'SetLocalStorage',
                                                                        key:
                                                                            'AuthorizeUserInfo',
                                                                        value: {
                                                                            items,
                                                                            url,
                                                                            token,
                                                                        },
                                                                    }
                                                                );
                                                                location.reload();
                                                            }
                                                        }, 500);
                                                    }
                                                }
                                            );
                                        }
                                    }
                                );
                            }
                        }
                    }
                }
            );
        } else if (
            location.href.includes('wxwerp.com') &&
            !location.href.includes('kpi.wxwerp.com')
        ) {
            chrome.runtime.sendMessage(
                {
                    act: 'GetLocalStorage',
                    keys: ['AuthorizeUserInfo'],
                },
                function(e) {
                    const { AuthorizeUserInfo } = e.config;
                    if (AuthorizeUserInfo) {
                        const { items, url, token, replaceUrl } = JSON.parse(
                            AuthorizeUserInfo
                        );
                        if (items.length > 0) {
                            setTimeout(() => {
                                const data = location.search
                                    .split('&')
                                    .find(item => item.includes('sid='));
                                if (!replaceUrl) items.shift();
                                chrome.runtime.sendMessage({
                                    act: 'SetLocalStorage',
                                    key: 'AuthorizeUserInfo',
                                    value: {
                                        items,
                                        url,
                                        token,
                                        sid: data
                                            ? data
                                                  .replace('?', '')
                                                  .replace('sid=', '')
                                            : '',
                                    },
                                });
                                if (items.length > 0)
                                    location.href = replaceUrl || url;
                            }, 1000);
                        }
                    }
                }
            );
        }
    };

    _.tryAutoOrder = function() {
        chrome.runtime.sendMessage(
            {
                act: 'GetLocalStorage',
                keys: ['OrderData'],
            },
            function(e) {
                const { OrderData } = e.config;
                if (OrderData) {
                    const data = JSON.parse(OrderData);
                    const { num, token } = data;

                    // 1688
                    const is1688_1 = location.href.includes(
                        'trade.1688.com/order/new_step_order_detail'
                    );
                    const is1688_2 = location.href.includes(
                        'trade.1688.com/order/trade_flow'
                    );
                    const is1688_3 = location.href.includes(
                        'alipay.com/business/cashiermain'
                    );

                    // pdd
                    const isPdd_1 = location.href.includes(
                        'mobile.yangkeduo.com/order'
                    );
                    const isPdd_2 = location.href.includes(
                        'mclient.alipay.com/home/exterfaceAssign'
                    );
                    const isPdd_3 = location.href.includes(
                        'mclient.alipay.com/h5/loginIdPwdToLogin'
                    );
                    const isPdd_4 = location.href.includes(
                        'mclient.alipay.com/h5/cashierView'
                    );

                    if (num == 1 && (isPdd_1 || is1688_1)) {
                        chrome.runtime.sendMessage({
                            act: 'SetLocalStorage',
                            key: 'OrderData',
                            value: { num: Number(num) + 1, token },
                        });
                        chrome.runtime.sendMessage(
                            {
                                act: 'GetPurchaseInfo',
                                data: { token, url: location.href },
                            },
                            function(e) {
                                console.log(e);
                                if (e.success) {
                                    if (isPdd_1) {
                                        $(
                                            "div[aria-label='可选支付宝']"
                                        ).click();
                                        $("div:contains('去支付')").click();
                                    } else if (is1688_1) {
                                        $("a:contains('付款')")[0].click();
                                    }
                                }
                            }
                        );
                    } else if (
                        (num == 2 && (isPdd_2 || is1688_2)) ||
                        (num == 3 && (isPdd_3 || is1688_3))
                    ) {
                        chrome.runtime.sendMessage({
                            act: 'SetLocalStorage',
                            key: 'OrderData',
                            value: { num: Number(num) + 1, token },
                        });
                        chrome.runtime.sendMessage(
                            {
                                act: 'GetLocalStorage',
                                keys: ['AlipayInfo'],
                            },
                            function(e) {
                                const { AlipayInfo } = e.config;
                                if (AlipayInfo) {
                                    const { username, password } = JSON.parse(
                                        AlipayInfo
                                    );
                                    if (isPdd_2) {
                                        if (
                                            $("button:contains('确认付款')")
                                                .length > 0
                                        ) {
                                            $(
                                                "button:contains('确认付款')"
                                            ).click();
                                            setTimeout(() => {
                                                $('#pwd_unencrypt').val(
                                                    password
                                                );
                                                $('#spwd').val(password);
                                                $('#pwd_unencrypt').keyup();
                                                chrome.runtime.sendMessage({
                                                    act: 'SetPayDone',
                                                    data: {
                                                        token,
                                                        url: location.href,
                                                    },
                                                });
                                            }, 500);
                                        } else if (
                                            $("h4:contains('输入支付密码')")
                                                .length > 0
                                        ) {
                                            $('#pwd_unencrypt').val(password);
                                            $('#spwd').val(password);
                                            $('#pwd_unencrypt').keyup();
                                            chrome.runtime.sendMessage({
                                                act: 'SetPayDone',
                                                data: {
                                                    token,
                                                    url: location.href,
                                                },
                                            });
                                        } else {
                                            const a = $(
                                                "a:contains('支付密码登录')"
                                            );
                                            if (a.length > 0) a[0].click();
                                        }
                                    } else if (isPdd_3) {
                                        $('#logon_id').val(username);
                                        $(
                                            "span:contains('使用长密码')"
                                        ).click();
                                        $('#pwd_unencrypt').val(password);
                                        $('#pwd').val(password);
                                        $("button:contains('下一步')").click();
                                        chrome.runtime.sendMessage({
                                            act: 'SetPayDone',
                                            data: {
                                                token,
                                                url: location.href,
                                            },
                                        });
                                    } else if (is1688_2) {
                                        $("button:contains('去付款')").click();
                                    } else if (is1688_3) {
                                        setTimeout(() => {
                                            let doc = window.frames['0'];
                                            if (window.frames['1'])
                                                window.frames['1'];
                                            $(doc.document)
                                                .find('#payPassword_rsainput')
                                                .val(password);
                                            $(doc.document)
                                                .find('#validateButton')
                                                .click();
                                            chrome.runtime.sendMessage({
                                                act: 'SetPayDone',
                                                data: {
                                                    token,
                                                    url: location.href,
                                                },
                                            });
                                        }, 3000);
                                    }
                                }
                            }
                        );
                    } else if (num > 1 && isPdd_4) {
                        $('.am-button').click();
                        chrome.runtime.sendMessage({
                            act: 'SetPayDone',
                            data: {
                                token,
                                url: location.href,
                            },
                        });
                    }
                }
            }
        );
    };

    _.trySavePurchaseMd5 = function() {
        // 判断路径格式
        var url = window.location.toString();
        if (url.includes('/html/go.html?id=')) {
            //var md5 = url.split("/html/go.html?id=")[1];
            var done = false;
            var start = function() {
                var json = $('#result').html(); // 来自 go.html 脚本

                if (json && json.length > 0) {
                    var e = JSON.parse(json);

                    if (e && e.success) {
                        done = true;
                        clearInterval(hI);

                        chrome.runtime.sendMessage(
                            {
                                act: 'SavePurchaseMd5',
                                data: e.data,
                            },
                            function(e) {}
                        );
                    }
                }
            };

            start();

            // 从模板中获取数据
            if (!done) {
                var hI = setInterval(function() {
                    start();
                }, 100);
            }
        }
    };

    _.tryShowPurchase = function() {
        // 测试
        //debugger;
        //https://item.taobao.com/item.htm?id=683157622418

        chrome.runtime.sendMessage(
            {
                act: 'GetPurchaseMd5',
                data: {
                    url: window.location.toString(),
                    referrer: document.referrer.toString(),
                },
            },
            function(e) {
                if (e.success) {
                    var data = e.data.data;
                    var side = new Side(data);
                    chrome.runtime.sendMessage(
                        {
                            act: 'SavePurchaseMd5',
                            data: '',
                        },
                        function(e) {}
                    );
                    setTimeout(() => {
                        side.show();
                    }, 1000);
                } else {
                    if (e.skip == false) _.showMessage(e);
                }
            }
        );
    };

    _.load = function() {
        var url = wxwUtil.getUrl();
        var regexItem = _.GetGatherRegexItem(url);

        if (regexItem == null) return;

        var isRegexButtons = false;

        if (url.match(regexItem.url_regex)) {
            isRegexButtons = true;
        }

        if (isRegexButtons) {
            chrome.runtime.sendMessage(
                {
                    act: 'GetLocalStorage',
                    keys: [
                        'IsShowButtonInPage',
                        'IsShowGatherButton',
                        'IsShowCollectButton',
                    ],
                },
                function(e) {
                    const {
                        IsShowButtonInPage,
                        IsShowGatherButton,
                        IsShowCollectButton,
                        IsAutoSlideAE,
                    } = e.config;

                    _.IsShowButtonInPage = IsShowButtonInPage || 'true';
                    _.IsShowGatherButton = IsShowGatherButton || 'false';
                    _.IsShowCollectButton = IsShowCollectButton || 'true';
                    _.IsAutoSlideAE = IsAutoSlideAE || 'true';

                    _.wrapImageLinks(regexItem.buttons);
                }
            );
        }
    };

    _.doneResponse = {}; // {doneid:response}
    _.doneTimer = {};

    _.startInjects = function(scriptName, response) {
        var url = wxwUtil.getUrl();
        var regexItem = _.GetGatherRegexItem(url);

        if (regexItem && regexItem.injects) {
            for (var i = 0; i < regexItem.injects.length; i++) {
                var isMatched = false;

                for (var j = 0; j < regexItem.injects[i].regexs.length; j++) {
                    if (url.match(regexItem.injects[i].regexs[j])) {
                        isMatched = true;
                        break;
                    }
                }

                if (isMatched && regexItem.injects[i][scriptName]) {
                    var th = document.getElementsByTagName('body')[0];
                    var s = document.createElement('script');
                    s.setAttribute('type', 'text/javascript');

                    var doneid = new Date().getTime();
                    _.doneResponse[doneid] = response;
                    _.doneTimer[doneid] = setTimeout(() => {
                        if (_.IsRepsponseDone) return;
                        console.log('GatherTimeout');
                        _.onFinishGatherCurrentHtml(null, response);
                    }, 15000);

                    if (scriptName == 'site') {
                        s.setAttribute(
                            'src',
                            chrome.runtime.getURL(
                                `injects/${regexItem.injects[i].site}/StartGather.js`
                            )
                        );
                        var s1 = document.createElement('script');
                        s1.setAttribute('type', 'text/javascript');
                        s1.innerHTML = `window.doneid=${doneid}`;
                        th.appendChild(s1);
                        console.log('startInjects onStartGather');
                    } else {
                        s.innerHTML = regexItem.injects[i][
                            scriptName
                        ].replaceAll('%DONEID%', doneid); // 从服务端注入脚本
                        console.log('startInjects ' + scriptName);
                    }

                    th.appendChild(s);

                    return true;
                }
            }
        }

        return false;
    };

    _.GetGatherRegexItem = function(url) {
        if (!_.GATHER_REGEXS) return;

        for (var key in _.GATHER_REGEXS) {
            if (url.match(key)) {
                return _.GATHER_REGEXS[key];
            }
        }
    };

    _.startListen = function() {
        window.addEventListener('message', function(e) {
            if (
                e.command == 'finish_gather_current_html' ||
                e.data.command == 'finish_gather_current_html'
            ) {
                if (_.doneTimer[e.data.doneid])
                    clearTimeout(_.doneTimer[e.data.doneid]);
                if (_.doneResponse[e.data.doneid]) {
                    const url = location.origin + location.pathname;
                    if (_.ResponseBodyUrls.includes(url)) {
                        chrome.runtime.sendMessage(
                            {
                                act: 'getResponseBody',
                                url: location.href,
                            },
                            data => {
                                let html = e.data.html;
                                if (data) html = data;
                                _.onFinishGatherCurrentHtml(
                                    html,
                                    _.doneResponse[e.data.doneid],
                                    e.data.exts
                                );
                            }
                        );
                    } else {
                        _.onFinishGatherCurrentHtml(
                            e.data.html,
                            _.doneResponse[e.data.doneid],
                            e.data.exts
                        );
                    }
                }
            } else if (e.data.type == 'url_transfer_base64') {
                let url = e.data.url;
                if (url.indexOf('//') == 0) url = 'https:' + url;
                if (chrome.app.isInstalled === undefined) {
                    location.reload();
                } else {
                    chrome.runtime.sendMessage(
                        {
                            act: 'urlTransferBase64',
                            url,
                        },
                        res => {
                            window.postMessage(
                                {
                                    type: 'get_result_base64',
                                    ...res,
                                },
                                '*'
                            );
                        }
                    );
                }
            } else if (e.data.type == 'sku_purchase_order_payment') {
                chrome.runtime.sendMessage({
                    act: 'SetLocalStorage',
                    key: 'OrderData',
                    value: { num: '1', token: e.data.token },
                });
            } else if (e.data.type == 'authorize_shop') {
                chrome.runtime.sendMessage(
                    {
                        act: 'SetLocalStorage',
                        key: 'AuthorizeUserInfo',
                        value: e.data.datas,
                    },
                    () => {
                        window.open(e.data.datas.url);
                    }
                );
            } else if (e.data.type == 'download_images') {
                _.downloadImages = JSON.parse(e.data.urls);
                _.downloadBase64List = [];
                _.downloadImageIndex = 0;
                _.getDownloadImagesBase64();
                return;
            }
        });

        chrome.runtime.onMessage.addListener(function(
            message,
            sender,
            response
        ) {
            if (_[message.act]) {
                _[message.act](message, response, sender);
                return true;
            }
        });
    };

    //_.setHeaders = function (res) {
    //    window.setedHeaders = true;
    //    window.test = 'aaa';
    //    console.log("window.test = 'aaa';");
    //    if (window.OnSetHeaders) {
    //        console.log("aaaaaaaaaaaaaaaaaa");
    //        window.OnSetHeaders(res.data);
    //    } else {
    //        console.log("ccccccccccccc");
    //    }
    //};

    _.getDownloadImagesBase64 = function() {
        const item = _.downloadImages[_.downloadImageIndex];
        if (item) {
            let { url, name } = item;
            if (url.indexOf('//') == 0) url = 'https:' + url;
            chrome.runtime.sendMessage(
                {
                    act: 'urlTransferBase64',
                    url,
                },
                res => {
                    _.downloadBase64List.push({ base64: res.base64, name });
                    _.downloadImageIndex++;
                    _.getDownloadImagesBase64();
                }
            );
        } else {
            let zip = new JSZip();
            let obj = {
                imagesImg: zip.folder('images'),
                skusImg: zip.folder('skus'),
                detailsImg: zip.folder('details'),
            };
            _.downloadBase64List.forEach((data, index) => {
                try {
                    obj[`${data.name}Img`].file(
                        `${data.name}_${index}.jpg`,
                        data.base64.replace(
                            /^data:image\/(png|jpg);base64,/,
                            ''
                        ),
                        {
                            base64: true,
                        }
                    );
                } catch (e) {}
            });
            zip.generateAsync({
                type: 'blob',
            }).then(function(content) {
                window.postMessage(
                    {
                        type: 'get_zip_href',
                        href: URL.createObjectURL(content),
                    },
                    '*'
                );
            });
        }
    };

    _.getWindowName = function(data, response) {
        response({ name: window.name });
    };

    _.isLoadFinished = function(data, response) {
        response({ success: true });
    };

    console.log('start 1.0');

    _.gatherCurrentItems = function(data, response) {
        console.log('gatherCurrentItems 1.0');

        var url = wxwUtil.getUrl();

        var found = false;

        for (var key in _.GATHER_REGEXS) {
            if (url.match(key)) {
                found = true;
            }
        }

        if (!found) {
            return;
        }

        // 将所有的资料全部获取
        var datas = [];
        $('.btn_wxwgather').each(function() {
            var url =
                $(this).attr('href') ||
                $(this)
                    .find('a')
                    .attr('href');
            if (!url) return;
            var item = getGatherItemByButton($(this), url);
            if (!item) return;
            datas.push(item);
        });

        var url = wxwUtil.getUrl();
        var regexItem = _.GetGatherRegexItem(url);

        if (!regexItem.shop_regex || !url.match(regexItem.shop_regex)) {
            /*
            START START START START
            检查重复图片，将其过滤掉
            检查重复图片，将其过滤掉
            检查重复图片，将其过滤掉
            */
            var obj = {};
            datas = datas.reduce(function(item, next) {
                obj[next.imageUrls[0]]
                    ? ''
                    : (obj[next.imageUrls[0]] = true && item.push(next));
                return item;
            }, []);

            var repeatImages = {}; // url : 0
            var repeatTexts = {}; // text : 0

            for (var i = 0; i < datas.length; i++) {
                for (var j = 0; j < datas[i].imageUrls.length; j++) {
                    if (!repeatImages[datas[i].imageUrls[j]])
                        repeatImages[datas[i].imageUrls[j]] = 1;
                    else repeatImages[datas[i].imageUrls[j]]++;
                }

                if (!repeatTexts[datas[i].text]) repeatTexts[datas[i].text] = 0;

                repeatTexts[datas[i].text]++;
            }

            if (!_.IsDoba) {
                var removes = [];

                for (var i = 0; i < datas.length; i++) {
                    if (
                        repeatImages[datas[i].image] &&
                        repeatImages[datas[i].image] > 1
                    ) {
                        var foundReplace = null;

                        for (var j = 0; i < datas[i].imageUrls.length; j++) {
                            if (
                                repeatImages[datas[i].imageUrls[j]] &&
                                repeatImages[datas[i].imageUrls[j]] > 1
                            ) {
                                foundReplace = datas[i].imageUrls[j];
                                break;
                            }
                        }

                        if (foundReplace) datas[i].image = foundReplace;
                        else {
                            removes.push(datas[i]); // 去重会导致全去
                        }
                    }

                    // 遇到重复的文本，则移除掉
                    if (
                        repeatTexts[datas[i].text] &&
                        repeatTexts[datas[i].text] > 1
                    ) {
                        if (
                            datas.filter(el => el.image == datas[i].image)
                                .length > 1
                        )
                            removes.push(datas[i]);
                    }

                    if (datas[i].text.includes('采到')) {
                        removes.push(datas[i]);
                    }
                }

                for (var i = 0; i < removes.length; i++) {
                    datas.remove(removes[i]);
                }
            }

            /*
            END END END END 
            检查重复图片，将其过滤掉
            检查重复图片，将其过滤掉
            检查重复图片，将其过滤掉
            */
        }

        // 获取注入的函数
        if (_.startInjects('onStartGetItems', response)) return;

        response({
            items: JSON.stringify(datas),
        });
    };

    Array.prototype.indexOf = function(val) {
        for (var i = 0; i < this.length; i++) {
            if (this[i] == val) return i;
        }
        return -1;
    };

    Array.prototype.remove = function(val) {
        var index = this.indexOf(val);
        if (index > -1) {
            this.splice(index, 1);
        }
    };

    _.testUi = function(data, response) {
        response({ ok: true });
    };

    _.gatherCurrentHtml = function(res, response) {
        var url = wxwUtil.getUrl();
        var found = false;
        if (res.data) {
            _.TabInfo = {
                originUrl: res.data.originUrl,
                tabid: res.data.tabid,
            };
        }
        if (_.GATHER_REGEXS.length == 0) {
            if (res.data) {
                chrome.runtime.sendMessage({
                    act: 'gatherHtmlDone',
                    data: {
                        url: window.location.toString(),
                        html:
                            "{success:false, message : '" +
                            getI18n('未成功连接服务器，请重新启动插件再试') +
                            "'}",
                        nothing: true,
                        ..._.TabInfo,
                    },
                });
            } else {
                _.onFinishGatherCurrentHtml(
                    "{success:false, message : '" +
                        getI18n('未成功连接服务器，请重新启动插件再试') +
                        "'}",
                    response
                );
            }
            return;
        }

        for (var key in _.GATHER_REGEXS) {
            if (url.match(key)) {
                found = true;
            }
        }

        if (!found) {
            if (res.data) {
                chrome.runtime.sendMessage({
                    act: 'gatherHtmlDone',
                    data: {
                        url: window.location.toString(),
                        html:
                            "{success:false, message : '" +
                            getI18n('暂不支持采集') +
                            ' ' +
                            url +
                            "'}",
                        nothing: true,
                        ..._.TabInfo,
                    },
                });
            } else {
                _.onFinishGatherCurrentHtml(
                    "{success:false, message : '" +
                        getI18n('暂不支持采集') +
                        ' ' +
                        url +
                        "'}",
                    response
                );
            }
            return;
        }

        // 获取注入的函数
        if (_.startInjects('site', response) && !url.includes('getcookie=true'))
            return;

        var html = document.getElementsByTagName('html')[0].outerHTML;
        if (url.includes('getcookie=true')) html = document.cookie;

        if (res.data) {
            chrome.runtime.sendMessage({
                act: 'gatherHtmlDone',
                data: {
                    url: window.location.toString(),
                    html: html,
                    nothing: true,
                    ..._.TabInfo,
                },
            });
        } else {
            _.onFinishGatherCurrentHtml(html, response);
        }
    };

    _.onFinishGatherCurrentHtml = function(html, response, exts) {
        console.log('onFinishGatherCurrentHtml');
        if (exts == null || !exts.delay) {
            _.IsRepsponseDone = true;
            response({
                url: window.location.toString(),
                html: html,
                exts: exts,
                nothing: true,
                ..._.TabInfo,
            });
        } else if (exts.arr) {
            /// 拼多多延迟提交
            chrome.runtime.sendMessage(
                {
                    act: 'setDelayFinishGatherCurrentHtml',
                    html: html,
                    exts: exts,
                    url: window.location.toString(),
                    next: true,
                    ..._.TabInfo,
                },
                function(e) {}
            );
        }
    };

    _.shownFavoriteCollectionButton = false;

    _.showCollectBtn = function() {
        if (_.shownFavoriteCollectionButton) return;

        var html = [];

        // 该页面是否属于详情页
        var isProductDetailPage = false;
        var url = wxwUtil.getUrl();

        var regexItem = new GatherRegex(_.GATHER_REGEXS).GetGatherRegexItem(
            url
        );

        if (!regexItem) {
            return;
        }

        isProductDetailPage = new GatherRegex(
            _.GATHER_REGEXS
        ).IsUrlInDetailRegex(url);

        html.push('<div class=wxwRightFixedPanel>');

        if (isProductDetailPage) {
            if (_.IsShowGatherButton == 'true') {
                html.push(
                    "<div class='btnButton btnCollect'>" +
                        getI18n('采集') +
                        '</div>'
                );
            }
            if (_.IsShowCollectButton == 'true') {
                html.push(
                    "<div class='btnButton productBtnFavorite'>" +
                        getI18n('收藏') +
                        '</div>'
                );
            }
            _.shownFavoriteCollectionButton = true;
        } else if ($('.btn_wxwgather').length > 0) {
            html.push(
                "<div class='btnButton btnFavorite'>" +
                    getI18n('收藏') +
                    '</div>'
            );
            _.shownFavoriteCollectionButton = true;
        }

        html.push('</div>');

        $('body').append(html.join(''));

        $('.btnCollect').click(function() {
            // 根据当前页面的正则判断，如果该页面属于单产品页面，则直接采集，若当前页面是列表页面，则加入到收藏夹
            debugger;
            if (regexItem) {
                if (regexItem.buttons) {
                    var found = false;

                    for (var i = 0; i < regexItem.buttons.length; i++) {
                        if (url.match(regexItem.buttons[i])) {
                            found = true;
                        }
                    }

                    if (found)
                        chrome.runtime.sendMessage(
                            {
                                act: 'fetchToGatherBox',
                                command: 'gather_from_current_page',
                                message: getI18n('正在采集产品..'),
                            },
                            function(e) {
                                _.showMessage(e);
                            }
                        );

                    return;
                }
            }

            debugger;
            _.showMessage({
                success: true,
                message: getI18n('暂不支持采集本页面1'),
            });
        });

        $('.btnFavorite').click(function() {
            chrome.runtime.sendMessage(
                {
                    act: 'fetchToGatherBox',
                    command: 'favorite_all',
                    message: getI18n('正在收藏该页的产品..'),
                },
                function(e) {
                    if (!e.success) {
                        _.showMessage(e);
                        return;
                    }
                }
            );
        });

        $('.productBtnFavorite').click(function() {
            // 根据当前页面的正则判断，如果该页面属于单产品页面，则直接采集，若当前页面是列表页面，则加入到收藏夹
            if (regexItem) {
                if (regexItem.buttons) {
                    var found = false;

                    for (var i = 0; i < regexItem.buttons.length; i++) {
                        if (url.match(regexItem.buttons[i])) {
                            found = true;
                        }
                    }

                    if (found)
                        chrome.runtime.sendMessage(
                            {
                                act: 'fetchToGatherBox',
                                command: 'gather_from_current_item',
                                message: getI18n('正在收藏产品..'),
                            },
                            function(e) {
                                _.showMessage(e);
                            }
                        );

                    return;
                }
            }
            debugger;

            _.showMessage({
                success: true,
                message: getI18n('暂不支持采集本页面2'),
            });
        });
    };

    var config = { attributes: true, childList: true }; //配置对象

    var getGatherItemByButton = function(btn, url) {
        // 通过 btn 找到元素周围的图像和内容
        var images = btn.find('img');

        var imageUrl;
        var imageUrls = [];

        function findBgImg(element) {
            if (imageUrl) return;
            let bgImg = element.css('backgroundImage');
            if (!bgImg || bgImg == 'none') {
                if (element.src) bgImg = element.src;
                else bgImg = element[0].src;
            }
            if (bgImg && bgImg != 'none') return (imageUrl = bgImg);
            if (element.children().length > 0) {
                element.children().each(function() {
                    return findBgImg($(this));
                });
            }
        }
        if (!images || images.length == 0) {
            if (_.IsSzwego || _.IsPtAliexpress) {
                btn.parent()
                    .find('img')
                    .each(function() {
                        imageUrls.push($(this).attr('src'));
                    });
                if (imageUrls.length > 0) imageUrl = imageUrls[0];
            } else {
                imageUrl = $(this)
                    .find('div.img')
                    .css('backgroundImage');
            }

            if (!imageUrl)
                imageUrl = btn.find('div.img').css('backgroundImage');

            if (!imageUrl) {
                btn.parent()
                    .find('div.img')
                    .each(function() {
                        findBgImg($(this));
                    });
            }

            if (!imageUrl) {
                btn.prevAll().each(function() {
                    findBgImg($(this));
                });
            }

            if (!imageUrl) {
                btn.closest('div').each(function() {
                    findBgImg($(this));
                });
            }

            if (
                imageUrl != null &&
                imageUrl != '' &&
                imageUrl.indexOf('url(') > -1
            ) {
                var last = imageUrl.indexOf(')');
                var first = imageUrl.indexOf('(');

                imageUrl = imageUrl
                    .substring(first + 1, last)
                    .replace('"', '')
                    .replaceAll('"', '');
            }

            imageUrls.push(imageUrl);
        } else {
            images.each(function() {
                imageUrls.push($(this).attr('src'));
            });
            imageUrl = images.attr('src');
        }

        var protocol = location.protocol;

        imageUrls = imageUrls.filter(url => url);

        if (!imageUrl) imageUrl = imageUrls[0];

        if (!images || !imageUrl) {
            //debugger;
            return;
        }

        if (url && url.indexOf('http') != 0 && url.indexOf('//') != 0) {
            if (url.indexOf('/') != 0) url = origin + '/' + url;
            else url = origin + url;
        }

        if (url && url.indexOf('//') == 0) {
            url = protocol + url;
        }

        var subject = '';

        if (images && images.attr('alt'))
            subject = images
                .attr('alt')
                .toString()
                .trim();

        if (subject) {
            subject = subject.replaceAll('\n', ' ');
        }

        var html = '';
        var price = '';

        /// 不断轮询5级，直到找到有数值的项目
        var parent = btn;

        function getInnerTextWithoutClass(element, ignores) {
            var text = '';
            var className = $(element).attr('class');
            var value = $(element)
                .text()
                .trim();
            var contents = $(element).contents();

            if (!className) text += value;
            else if (
                !ignores.find(el =>
                    className.toLowerCase().includes(el.toLowerCase())
                )
            ) {
                if (contents.length > 0) {
                    contents.each(function() {
                        text += getInnerTextWithoutClass(this, ignores);
                    });
                } else text += value;
            }

            return text;
        }

        for (var i = 0; i < 10; i++) {
            var ignores = ['price', 'mango-link-next'];
            if (_.Is1688) {
                ignores = ['cpv', 'offerTag', 'price', 'company', 'zr-dpa'];
            } else if (_.IsDhgate) {
                ignores = [
                    'gallery-promo-wrap',
                    'categorylink-conatiner-item-morewarp',
                    'gallery-price-wrap',
                    'gellery-product-info',
                    'gallery-store-info',
                    'gallery-discount-wrap',
                ];
            } else if (_.IsAliexpress) {
                ignores = ['discount', 'cost', 'cost-old', 'recent-order'];
            } else if (_.IsDoba) {
                parent = parent.parent();
                ignores = [
                    'image-wrap',
                    'img-wrapper',
                    'format-price-wrap',
                    'profit-tag',
                    'img-box',
                ];
            } else if (_.IsShein) {
                ignores = [
                    'bottom-wrapper__price-wrapper',
                    'product-card__selling-proposition-container',
                ];
            }
            var text = getInnerTextWithoutClass(parent, ignores);
            if (_.IsAlibaba) {
                if (text.includes(_.IsShowLogo ? '收藏到旺销王' : '收藏')) {
                    if (text.includes('Add to Favorites')) {
                        var result = '';
                        text = text.replace('Add to Favorites', '');
                        text.split(
                            _.IsShowLogo ? '收藏到旺销王' : '收藏'
                        ).forEach(item => {
                            if (item.length > 5 && item.length > result.length)
                                result = item;
                        });
                        text = result;
                    } else {
                        text = text.replace(
                            _.IsShowLogo ? '收藏到旺销王' : '收藏',
                            ''
                        );
                    }
                }
                if (text.indexOf('Compare') == 0)
                    text = text.replace('Compare', '');
            } else if (_.IsDhgate) {
                text = text
                    .replaceAll(_.IsShowLogo ? '收藏到旺销王' : '收藏', '')
                    .replaceAll('正在采集中...', '');
                var str = text.split('+')[0];
                if (!isNaN(parseFloat(str)) && isFinite(str))
                    text = text.replace(str + '+', '');
            } else if (
                _.Is1688 ||
                _.IsLazada ||
                _.IsAliexpress ||
                _.IsDhgateSeller ||
                _.IsDoba ||
                _.IsShein
            ) {
                text = text
                    .replaceAll(_.IsShowLogo ? '收藏到旺销王' : '收藏', '')
                    .replaceAll('正在采集中...', '');
            }

            if (!text || text == getI18n('正在采集中...')) {
                parent = parent.parent();
                continue;
            }

            if (subject == null || subject == '') {
                subject = text;
            }

            var matcheds = text
                .replaceAll(getI18n('正在采集中...'), '')
                .match(/[\d\.]+/); // 找到有价格才放弃？

            if (!matcheds) {
                parent = parent.parent();
                continue;
            }

            if (matcheds.length > 0 && matcheds[0]) {
                price = matcheds[0];
                if (_.IsDoba) {
                    price = parent.find('.format-price-wrap').attr('title');
                    if (!price) price = parent.find('.price').text();
                }
                if (price != '') {
                    try {
                        html = parent.get()[0].innerHTML;
                    } catch (e) {
                        html = btn.get()[0].innerHTML;
                    }
                    break;
                }
            }

            parent = parent.parent();
        }

        if (price == '' || price == null) {
            try {
                html = parent.get()[0].innerHTML;
            } catch (e) {
                html = btn.get()[0].innerHTML;
            }
        }

        if (subject == '' || subject == null) {
            subject = parent.get()[0].innerText;
        }

        if (subject.includes(getI18n('正在采集中...'))) {
            subject = subject.replaceAll(getI18n('正在采集中...'), '');
        }

        subject = subject
            .replaceAll('\r', '')
            .replaceAll('\n', '')
            .trim();

        if (subject.length > 100) subject = subject.substring(0, 100) + '...';

        if (html.length > 1000) html = html.substring(0, 1000) + '...';

        return {
            url: url,
            image: imageUrl,
            imageUrls: imageUrls,
            text: subject,
            price,
            html: html,
        };
    };

    _.wrapImageLinks = function(buttonsRegex) {
        $('a:not(.wxw_checked)').each(function() {
            var a = $(this);
            var href = a.attr('href') || a.attr('data-href');
            if (_.IsDhgate) {
                if (
                    a.parents('.recommend-prod-list').length > 0 ||
                    a.parent().hasClass('categorylink-conatiner-item')
                )
                    return;
            } else if (_.Is1688) {
                if (a.parent().hasClass('mojar-element-title')) return;
            } else if (_.IsAlibaba) {
                if (
                    a.parents('.search-card-info__wrapper').length > 0 ||
                    a.parents('.card-info').length > 0
                )
                    return;
                if (
                    a.parent().hasClass('search-card-e-slider__wrapper') ||
                    a.parent().hasClass('vc-normalContainer')
                ) {
                    a = a.parent();
                }
            } else if (_.IsEbay) {
                if (a.parents('.s-item__info').length > 0) return;
                if (a.parent().hasClass('s-item__image')) {
                    a = a.parent();
                }
            } else if (_.IsAmazon) {
                if (a.parents('.puis-padding-left-small').length > 0) return;
            } else if (_.IsMiravia) {
                if (a.parents('.lte-product__pos--img').length > 0) return;
            } else if (_.IsShopeeSeller) {
                if (a.parents('.sidebar-submenu').length > 0) return;
            } else if (_.IsDhgateSeller) {
                if (a.parents('.container-content-sidebar').length > 0) return;
            } else if (_.IsXiapiBuy) {
                a.parents('.N_YeYe').css('position', 'relative');
            } else if (_.IsDoba) {
                if (
                    a.parents('.product-detail').length > 0 ||
                    a.hasClass('name') ||
                    a.parents('.product-attr').length > 0
                )
                    return;
                a = a.parent();
            } else if (_.IsYiwugo || _.IsBlibili) {
                a = a.parent();
            } else if (_.IsShein) {
                if (a.parents('.header-wrap').length > 0) return;
                if (a.parents('.header-optimize__cate-controller').length > 0)
                    return;
            } else if (_.IsTemu) {
                a = a.parent();
                a = a.parent();
            }

            if (a.hasClass('wxw_checked')) return;

            a.addClass('wxw_checked');

            var url = href || '';

            if (!url.includes('http') && !url.includes('//')) {
                if (url.indexOf('/') == 0) url = origin + href;
                else url = origin + '/' + href;
            }

            if (!href || href == '#' || href.indexOf('javascript:') == 0) {
                return;
            }

            var isRegexButtons = false;

            for (var i = 0; i < buttonsRegex.length; i++) {
                if (url.match(buttonsRegex[i])) {
                    isRegexButtons = true;
                    break;
                }
            }

            if (!isRegexButtons) return;

            a.addClass('btn_wxwgather');
            a.removeClass('tile-hover-target');

            if (_.IsShowButtonInPage !== 'true') return;
            var btn = a
                .append(
                    `<span class='wxw-link'>${getI18n(
                        _.IsShowLogo ? '收藏到旺销王' : '收藏'
                    )}</span>`
                )
                .find('.wxw-link:last');

            // 监听属性变化
            var observer = new MutationObserver(function(mutations) {
                mutations.forEach(function(record) {
                    if (
                        record.type == 'attributes' &&
                        btn.hasClass('clicked')
                    ) {
                        btn.removeClass('clicked');
                        btn.text(
                            getI18n(_.IsShowLogo ? '收藏到旺销王' : '收藏')
                        );
                    }
                });
            });
            observer.observe(a[0], config);

            isGatherBoxInline = getComputedStyle(this)['display'] === 'inline';

            if (
                isGatherBoxInline &&
                !_.IsAlibaba &&
                !_.IsEbay &&
                !_.IsAmazon &&
                !_.IsDoba &&
                !_.IsGigab2b &&
                !_.Is1688Detail
            )
                a.addClass('wxw-d-block');

            var height = a.height();

            isGatherBtnSmall = height < 100;

            if (isGatherBtnSmall) {
                btn.addClass('wxw-sm');

                if (btn.parents('a').find('img').length > 0) {
                    btn.parents('a')
                        .parent()
                        .css('overflow', 'visible');
                }
            }

            haveGahterItem = true;

            btn.click(function(e) {
                btn.text(getI18n('正在采集中...'));

                var href = a.attr('href') || a.attr('data-href');
                if (
                    _.IsAlibaba ||
                    _.IsEbay ||
                    _.IsYiwugo ||
                    _.IsBlibili ||
                    _.IsDoba ||
                    _.IsTemu
                )
                    href = a.find('a').attr('href');

                var item = getGatherItemByButton(btn, href);

                if (item == null) {
                    item = {};
                    item.url = a.attr('href');
                }

                if (!item.url) item.url = a.attr('href');

                item.act = 'fetchToGatherBox';
                item.command = 'gather_from_list_item';
                delete item.imageUrls;

                e.stopPropagation();

                chrome.runtime.sendMessage(item, function(e) {
                    if (!e.success) {
                        _.showMessage(e);
                        btn.addClass('failed');
                        btn.text(getI18n('失败'));
                        return;
                    }

                    btn.addClass('clicked');
                    btn.text(getI18n(e.message));
                });

                return false;
            });
        });

        // 由于页面可能动态加载，需要不断递归
        setTimeout(function() {
            _.wrapImageLinks(buttonsRegex);
            _.showCollectBtn();
        }, 1000);
    };

    var _createMessage = function(text, type) {
        $('div.wxw_message').remove();

        var HTML =
            "<div class='wxw_message " +
            type +
            "'>" +
            "<img class='wxw_logo' src='https://www.tferp.net/images/wxw_logo_white.png' />" +
            '<span>' +
            getI18n(text || '失败') +
            '</span>' +
            `<a class='close' href='javascript:void(0)' onclick='return false'>${getI18n(
                '关闭'
            )}</a>` +
            '</div>';

        $('body').append(HTML);

        var $messageBox = $('div.wxw_message:last');

        $messageBox.find('a.close').click(function() {
            $messageBox.hide();
        });

        return $messageBox;
    };

    _.showMessage = function(data) {
        if (!data) return;
        //debugger;
        var type = data.success ? 'success' : 'error';
        var text = data.message;
        var sleep = data.sleep;

        if (!sleep) sleep = 15000;

        var singleMessage = _createMessage(text, type);

        singleMessage
            //.removeClass()
            .addClass('wxw_message');

        singleMessage.show();

        clearTimeout(_._MESSAGE_DELAY_CLOSE);
        _._MESSAGE_DELAY_CLOSE = setTimeout(function() {
            singleMessage.hide();
        }, sleep);
    };
}

var __ui = null;

setTimeout(() => {
    __ui = new UI();
    __ui.init();
}, 0);

//chrome.runtime.sendMessage({ action: "getData" }, (response) => {
//    // 将接收到的数据注入到网页中
//    const scriptToInject = `
//    window.xxx = ${JSON.stringify(response.exampleData)};
//  `;

//    chrome.scripting.executeScript({
//        target: { tabId: sender.tab.id },
//        func: () => {
//            eval(scriptToInject);
//        }
//    });
//});
