﻿var wxwUtil = function() {
    var _ = this;

    _.local = true; // 是否位于开发者电脑
    _.test = false; // 是否为测试环境

    // 代码生成器识别区域，请勿删除下面的注释
    //##DOMAIN_START
    _.DOMAINS = _.test
        ? [
              {
                  id: 'local',
                  ws: 'ws://localhost:30002',
                  api: 'https://localhost:44330',
                  ui: 'https://localhost:44331',
              },
          ]
        : [
              {
                  id: 'v3',
                  ws: 'wss://v3-ws-chrome.tferp.net',
                  api: 'https://v3-api.tferp.net',
                  ui: 'https://v3.tferp.net',
              },
            //   {
            //       id: 'ae-pub',
            //       ws: 'wss://ae-pub-ws-chrome.tferp.net',
            //       api: 'https://ae-pub-api.tferp.net',
            //       ui: 'https://ae-pub.tferp.net',
            //   },
            //   {
            //       id: 'ali-pub',
            //       ws: 'wss://ali-pub-ws-chrome.tferp.net',
            //       api: 'https://ali-pub-api.tferp.net',
            //       ui: 'https://ali-pub.tferp.net',
            //   },
            //   {
            //       id: 'v3-test',
            //       ws: 'wss://v3-test-ws-chrome.tferp.net',
            //       api: 'https://v3-test-api.tferp.net',
            //       ui: 'https://v3-test.tferp.net',
            //   },
              {
                  id: 'local',
                  ws: 'ws://localhost:30002',
                  api: 'https://localhost:44330',
                  ui: 'https://localhost:44331',
              },
              // {
              //     id: 'v3-ali',
              //     ws: 'wss://v3-ws-chrome.tferp.net',
              //     api: 'https://v3-api.tferp.net',
              //     ui: 'https://marketplace.aliexpress.com',
              // },
          ];
    _.domains = [];
    //##DOMAIN_END

    _.VERSION = null;

    if (chrome && chrome.app && chrome.app.getDetails())
        _.VERSION = chrome.app.getDetails().version;

    _.language = 'zh';

    _.getUrl = function() {
        try {
            return window.top.location.toString();
        } catch {
            return '';
        }
    };

    _.urlToBase64 = function(url) {
        return new Promise((resolve, reject) => {
            let image = new Image();
            image.onload = function() {
                let canvas = document.createElement('canvas');
                canvas.width = this.naturalWidth;
                canvas.height = this.naturalHeight;
                // 将图片插入画布并开始绘制
                canvas.getContext('2d').drawImage(image, 0, 0);
                // result
                let base64 = canvas.toDataURL('image/png');
                resolve({ success: true, base64 });
            };
            // CORS 策略，会存在跨域问题https://stackoverflow.com/questions/20424279/canvas-todataurl-securityerror
            image.setAttribute('crossOrigin', 'Anonymous');
            image.src = url;
            // 图片加载失败的错误处理
            image.onerror = () => {
                resolve({ success: false, message: '图片加载失败' });
            };
        });
    };

    _.findStr = function(str, findStart, findEnd) {
        let l = str.indexOf(findStart);
        let r = str.indexOf(findEnd);

        function dep() {
            if (l > r) {
                let sub_len = r + findEnd.length;
                r = str.substring(sub_len).indexOf(findEnd) + sub_len;
                dep();
            }
        }

        dep();
        if (l == -1 || r == -1) return '';
        return str.substring(l + findStart.length, r);
    };

    _.$post = function(url, data = {}) {
        return new Promise((resolve, reject) => {
            chrome.runtime.sendMessage(
                {
                    act: 'requestWxwServer',
                    url,
                    data,
                    isApi: true,
                },
                function response(e) {
                    if (e.success) {
                        resolve(e);
                    } else {
                        reject(e);
                    }
                }
            );
        });
    };

    _.injectCode = function(code) {
        var th = document.getElementsByTagName('body')[0];
        var s = document.createElement('script');
        s.setAttribute('type', 'text/javascript');
        s.innerHTML = code;
        th.appendChild(s);
    };

    _.quick = function() {
        return new Promise((resolve, reject) => {
            chrome.runtime.sendMessage(
                {
                    act: 'quick',
                },
                function response(e) {
                    resolve();
                }
            );
        });
    };

    // wxwUtil.watingFor(function () { }, function () { return true; }, { sleep: 1000, timeout: 60000 });
    _.watingFor = function(runCallback, watingCallback, args) {
        if (!args) args = {};

        if (args.sleep == null) args.sleep = 300;
        var sleep = args.sleep;
        if (!args._runned) sleep = 1;
        args._runned = true;

        if (args.timeout && args.start == null) {
            args.start = new Date().getTime();
        }

        if (args.start && new Date().getTime() - args.start > args.timeout) {
            args.isTimeout = true;
            runCallback(args);
            return;
        }

        setTimeout(function() {
            if (watingCallback(args)) {
                runCallback(args);
            } else {
                _.watingFor(runCallback, watingCallback, args);
            }
        }, sleep);
    };
};

window.wxwUtil = new wxwUtil();

var GatherRegex = function(GATHER_REGEXS) {
    var _ = this;

    _.GetGatherRegexItem = function(url) {
        if (!GATHER_REGEXS) return;

        for (var key in GATHER_REGEXS) {
            if (url.match(key)) {
                return GATHER_REGEXS[key];
            }
        }
    };

    _.IsUrlInDetailRegex = function(url) {
        var regexItem = _.GetGatherRegexItem(url);

        if (regexItem && regexItem.buttons) {
            for (var i = 0; i < regexItem.buttons.length; i++) {
                if (url.match(regexItem.buttons[i])) return true;
            }
        }

        return false;
    };
};
